///////////////////////////////////////////////////////////////////////////////
// General.h

#ifndef __DEBUIG_PRINT_HOOK_H__
#define __DEBUIG_PRINT_HOOK_H__

extern "C" {

#pragma pack(push, 1)

#ifndef USER_MODE

#include <ntddk.h>                  // various NT definitions
#include <stddef.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include "ntddk_ex.h"
#include "tools.h"

#ifdef POOL_TAGGING
#ifdef ExAllocatePool
#undef ExAllocatePool
#endif
#define ExAllocatePool(a,b) ExAllocatePoolWithTag(a,b,'kHPD')
#endif

#define NT_DBGPRNHK_REG_PATH        L"SYSTEM\\CurrentControlSet\\Services\\DbgPrnHk"

#else //USER_MODE

#define NT_DBGPRNHK_REG_PATH        L"\\REGISTRY\\MACHINE\\SYSTEM\\CurrentControlSet\\Services\\DbgPrnHk"

#endif

#define NT_DBGPRNHK_REG_CHECK_IRQL_VAL   L"CheckIrql"
#define NT_DBGPRNHK_REG_BUFFER_SIZE_VAL  L"BufferSize"
#define NT_DBGPRNHK_REG_BLOCK_MSG_VAL    L"DoNotPassMessagesDown"

// Device names
#define NT_DbgPrnHk_DOS_NAME     ("\\DosDevices\\DbgPrnHk")
#define NT_DbgPrnHk_NAME         ("\\Device\\DbgPrnHk")
#define NT_DbgPrnHk_USER_NAME    ("\\\\.\\DbgPrnHk")
#define NT_DbgPrnHk_USER_NAME_W  (L"\\\\.\\DbgPrnHk")
#define NT_DbgPrnHk_SVC_NAME     ("DbgPrnHk")

#ifndef CTL_CODE
#include "winioctl.h"
#endif

#include "version.h"

#define DPHK_CTL_CODE_X(a,b)    CTL_CODE(FILE_DEVICE_UNKNOWN, a,b, FILE_ANY_ACCESS )

#define IOCTL_DbgPrnHk_GetMessages           DPHK_CTL_CODE_X(0x801, METHOD_BUFFERED)
#define IOCTL_DbgPrnHk_SetMessageBufferSize  DPHK_CTL_CODE_X(0x802, METHOD_BUFFERED)
#define IOCTL_DbgPrnHk_GetVersion            DPHK_CTL_CODE_X(0x803, METHOD_BUFFERED)
#define IOCTL_DbgPrnHk_PostMessage           DPHK_CTL_CODE_X(0x804, METHOD_BUFFERED)

#define MAX_MSG_SIZE  (128-sizeof(LARGE_INTEGER)-sizeof(PVOID)*2-sizeof(USHORT)-sizeof(UCHAR)*2-sizeof(UCHAR)*4)

typedef struct _DbgPrnHk_GetMessages_USER_OUT {
    LARGE_INTEGER TimeStamp;
    PVOID         ProcessId;
    PVOID         ThreadId;
    USHORT        Length;
    UCHAR         Irql;
    UCHAR         CpuNumber;
    UCHAR         Reserved[4];
    CHAR          Msg[MAX_MSG_SIZE];
} DbgPrnHk_GetMessages_USER_OUT, *PDbgPrnHk_GetMessages_USER_OUT;

typedef struct _DbgPrnHk_SetMessageBuffer_USER_IN {
    ULONG BufferSize;
} DbgPrnHk_SetMessageBuffer_USER_IN, *PDbgPrnHk_SetMessageBuffer_USER_IN;

typedef struct _DbgPrnHk_GetVersion_USER_OUT {
    ULONG         Major;
    ULONG         Minor;
    ULONG         Sub;
} DbgPrnHk_GetVersion_USER_OUT, *PDbgPrnHk_GetVersion_USER_OUT;

#ifndef USER_MODE

// Function declarations
extern NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath);
extern NTSTATUS DbgPrnHkCreateClose(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
extern NTSTATUS DbgPrnHkDeviceControl(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
extern VOID DbgPrnHkUnload(IN PDRIVER_OBJECT DriverObject);

#endif //USER_MODE

#pragma pack(pop)

};

#endif // __PCI_DUMP_H__

